<#--
This FreeMarker code is designed to be used with
Statestep models which contain embedded Python code.
The simplest way of employing this approach is
simply to copy this template code into the main
model.py.ftl file before processing that with FMPP.
See the HTML documentation for more about this.
-->

def extralogic(event, rule, current, next):
   '''Code extracted from the rules of the model.'''
   <@code_for_rules/><#lt>
   return next

<#--
For every rule in the model:
If executable code  for the rule is embedded in a comment
then output an 'if' statement to test for that particular
rule followed by the code extracted from the rule.
-->
<#macro code_for_rules>
   <#-- true until the first 'if' statement is written -->
   <#local first = true/>
   <#list doc.model.events.event as event>
      <#list event.rules.rule as rule>
         <#if rule.formula[0]?exists>
            <#local code_lines =
            rule.formula.text?matches("#:(.*)")
            />
            <#if code_lines?size != 0>
               <#t>   <#if !first>el</#if>
               if event == '${event.@name}'<#t>
               <#lt> and rule == '${rule.@name}':
               <#list code_lines as line>
                  <#t>      <#t>
                  <#lt>${line?groups[1]}
               </#list>
               <#local first = false/>
            </#if>
         </#if>
      </#list>
   </#list>
</#macro>
